import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

import java.awt.Color;
import java.awt.Graphics;
import java.lang.IllegalStateException;
/**
 * Counter that displays a number with a text prefix.
 * 
 * @author Michael Kolling
 * @version 1.0.2
 */
public class Counter extends Actor
{
    private static final Color textColor = Color.WHITE;
    
    private int value = 0;
    private int target = 0;
    private String text;
    private int stringLength;
    private Player p;
    public Counter()
    {
        this("", null);
    }

    public Counter(String prefix, Player a)
    {
        text = prefix;
        p = a;
        stringLength = (text.length() + 2) * 20;

        setImage(new GreenfootImage(stringLength, 18));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        updateImage();
    }
    
    public void act() {
        
        
        if(value < target) {
            //value++;
            value = target;
            updateImage();
        }
        else if(value > target) {
            value--;
            updateImage();
        }
        try
        {
        setLocation(p.getX()+80,p.getY()-30);
        }
        catch(IllegalStateException e)
        {
        setLocation(getWorld().getWidth()/2+80, getWorld().getHeight()/2)    ;
        }
        //}
    }

    public void add(int score)
    {
        target += score;
    }

    public void subtract(int score)
    {
        target -= score;
    }

    public int getValue()
    {
        return value;
    }

    /**
     * Make the image
     */
    private void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 1, 12);
    }
}
